
$script = 'tshark.pl';
$dir    = __FILE__;

$dir =~ s/$script$//g;
$dir = './'  unless $dir;

require "$dir" . "lib/default.include.pl";
require "$dir" . "lib/tools.database.pl";

#system("php $dir" . " getconfig.php");

&default_include_init();
&tools_database_init();

%hash = &database_select_as_hash("select 1, id from mod_cloudAstrixSPE_pcap where status='run'", 'id');
if ($hash{1}{id}) {
	warn "there is unfinished capture process, quit!\n";
	exit 0;
}

%hash = &database_select_as_hash("select
									 1, id,starttime,pfilter,`outfile`
								 from 
								 	mod_cloudAstrixSPE_pcap
								 where
								 	status='init' or
								 	status='run'
								 order by
								 	 starttime desc
								 limit 1",
								 'id,starttime,pfilter,outfile');
if (!$hash{1}{id}) {
	warn "no found new capture request, quit!\n";
	exit 0;
}


$filter = $hash{1}{pfilter};

$stop_file = "/tmp/tshark_stop";
$outfile  =  $hash{1}{outfile};
$p = fork();

if ($p <= 0) {
	$cmd = "tshark -f \"$filter\" -w $outfile";
	warn $cmd;
	system($cmd);
} else {
	&database_do("update mod_cloudAstrixSPE_pcap set status='run' where id='$hash{1}{id}'");
	$start = time;
	while (1) {
		if (time - $start > 600) {
			warn "quit capture for timeout!\n";
			system("touch $stop_file");
		}
		
		if (-e $stop_file) {
			$cmd = "pkill -TERM -P $p";
			warn "$cmd\n";
			system($cmd);
			
			unlink $stop_file;
			
			sleep 2;
			system("chmod a+r $hash{1}{outfile}");
			$size = -s $hash{1}{outfile};
			$size ||= 0;
			&database_do("update mod_cloudAstrixSPE_pcap set status='stop',filesize=$size,stoptime=now() where id='$hash{1}{id}'");
			exit 0;
		}
		sleep 1;
	}	
}

